name: C Release thumbv7em-none-eabihf 
run-name: Build-Release
on: [push]

jobs:
  Build-Release:
    runs-on: ubuntu-latest
    steps:

      - name: Install dependencies
        run: apt-get update && apt-get install -y gcc-arm-none-eabi binutils-arm-none-eabi ninja-build cmake protobuf-compiler python3 python3-grpcio python3-protobuf

      - name: Check out repository code
        uses: actions/checkout@v4
        with:
          submodules: true
          
      - name: Create Build directory
        run: mkdir build

      - name: Run CMake
        run: cmake --preset Release -B build -S .

      - name: Build
        run: cmake --build build

      - name: Archive production artifacts
        uses: actions/upload-artifact@v3
        with:
          name: firmware
          path: |
            build/*.hex
            build/*.bin